var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useMemo } from 'react';
import styled, { ThemeProvider } from 'styled-components';
import Masonry from 'react-masonry-css';
import { createTheme } from "../../theme";
import { Widget } from './Widget';
import { WidgetContextProvider } from './context';
import { initialDashboardTheme } from './dashboard-theme';
var Wrapper = styled(Masonry).withConfig({ displayName: "Wrapper", componentId: "sc-jnyqic" })({
    display: 'flex',
    width: '100%',
    '.masonryColumn': {
        margin: '0 1.5em',
        height: '100%',
    },
});
var breakpointColumns = {
    default: 2,
    760: 1,
};
var defaultConfig = {
    theme: {},
    widgets: {},
};
export var Dashboard = function (props) {
    var client = props.client, provider = props.provider, _a = props.config, config = _a === void 0 ? defaultConfig : _a;
    var theme = useMemo(function () { return createTheme(__assign(__assign({}, initialDashboardTheme), config.theme)); }, [config.theme]);
    return (React.createElement(ThemeProvider, { theme: theme },
        React.createElement(Wrapper, { breakpointCols: breakpointColumns, columnClassName: "masonryColumn", className: "masonryGrid" }, Object.keys(config.widgets || []).map(function (widgetConfigKey) { return (React.createElement(WidgetContextProvider, { key: widgetConfigKey, client: client, provider: provider, config: config.widgets[widgetConfigKey] },
            React.createElement(Widget, { as: config.widgets[widgetConfigKey].as }))); }))));
};
