import React from 'react';
import { PercentageProgressBar } from "../../../elements";
import { NewStatus } from './styles';
function getIndicator(_a) {
    var handedOver = _a.handedOver, teachingReviewerIds = _a.teachingReviewerIds, conversionReviewerIds = _a.conversionReviewerIds, conversionOwnerId = _a.conversionOwnerId, teachingOwnerId = _a.teachingOwnerId;
    if (handedOver) {
        return 'handshake';
    }
    if ((teachingOwnerId &&
        teachingReviewerIds &&
        teachingReviewerIds.length > 0) ||
        (conversionOwnerId &&
            conversionReviewerIds &&
            conversionReviewerIds.length > 0)) {
        return 'eye';
    }
}
function shouldShowTick(_a) {
    var commentsCount = _a.commentsCount, handedOver = _a.handedOver;
    return Boolean(handedOver) || Boolean(commentsCount && commentsCount > 0);
}
function getPopover(_a) {
    var commentsCount = _a.commentsCount, handedOver = _a.handedOver;
    if (handedOver) {
        return 'Handover done';
    }
    if (commentsCount && commentsCount > 0) {
        return 'Review finished';
    }
    return 'In review';
}
export var SessionItemProgress = function (_a) {
    var session = _a.session;
    var _b;
    if ((session === null || session === void 0 ? void 0 : session.progress) === null) {
        return React.createElement(NewStatus, null, "NEW");
    }
    return (React.createElement(PercentageProgressBar, { indicator: getIndicator(session), progress: Math.round(((_b = session === null || session === void 0 ? void 0 : session.progress) === null || _b === void 0 ? void 0 : _b.value) || 0), popover: getPopover(session), withTick: shouldShowTick(session) }));
};
