import React from 'react';
import { TableBody } from '../Table';
import { useInfiniteScroll } from './useInfiniteScroll';
import { RootFlexContainer, Wrapper, DefaultOutsideLoading } from './styles';
import { DefaultTableLoading, DefaultLoading } from './DefaultLoading';
import { DeafultTableLoadMore } from './DefaultLoadMore';
export var LazyTable = function (_a) {
    var hasNextPage = _a.hasNextPage, _b = _a.items, items = _b === void 0 ? [] : _b, loading = _a.loading, loadNextPage = _a.loadNextPage, isLoaded = _a.isLoaded, threshold = _a.threshold, registerScrollableList = _a.registerScrollableList, _c = _a.renderRoot, Root = _c === void 0 ? RootFlexContainer : _c, Table = _a.renderTable, Header = _a.renderHeader, renderRow = _a.renderRow, _d = _a.renderLoading, Loading = _d === void 0 ? DefaultTableLoading : _d, _e = _a.renderLoadingIndicator, LoadingIndicator = _e === void 0 ? DefaultLoading : _e, _f = _a.renderLoadMore, LoadMore = _f === void 0 ? DeafultTableLoadMore : _f, _g = _a.renderOutsideLoading, OutsideLoading = _g === void 0 ? DefaultOutsideLoading : _g, withPrefetchedData = _a.withPrefetchedData;
    var _h = useInfiniteScroll({
        loading: loading,
        hasNextPage: hasNextPage,
        itemsLength: items.length,
        isLoaded: isLoaded,
        onLoadMore: loadNextPage,
        registerScrollableList: registerScrollableList,
        threshold: threshold,
        withPrefetchedData: withPrefetchedData,
    }), infiniteRef = _h.ref, scrollable = _h.scrollable, scrollbarWidth = _h.scrollbarWidth, showLoadMore = _h.showLoadMore, tableMaxHeight = _h.tableMaxHeight;
    return (React.createElement(Root, null,
        React.createElement(Wrapper, { scrollbarWidth: scrollbarWidth },
            React.createElement(Table, null,
                React.createElement(Header, null),
                React.createElement(TableBody, { ref: infiniteRef, maxHeight: tableMaxHeight, tabIndex: 0 },
                    items.map(renderRow),
                    loading && !scrollable && (React.createElement(Loading, null,
                        React.createElement(LoadingIndicator, null))),
                    showLoadMore && React.createElement(LoadMore, { loadNextPage: loadNextPage }))),
            loading && scrollable && (React.createElement(OutsideLoading, null,
                React.createElement(LoadingIndicator, null))))));
};
